/*!
 * Copyright (c) 2019 han_feng@foxmail.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
 * OR OTHER DEALINGS IN THE SOFTWARE.
 */
import Vue from"vue";import createVuexAlong from"vuex-along";import router from"./router";import store from"./store";var HOOK_KEYS=Object.freeze({beforeEach:!0,beforeResolve:!0,afterEach:!0,onReady:!0,onError:!0});function addVuexModules(e){for(var r=e.getApplication(),o={name:"VAS:"+r.name+"-"+r.version},t=[],n=[],u=e.getExtension("vuex.modules"),a=0,i=Object.keys(u);a<i.length;a++){var s=i[a],c=u[s];store.registerModule(s,c),c.storage&&("session"===c.storage?n.push(s):"local"===c.storage&&t.push(s))}n.length>0&&(o.session={list:n}),t.length>0?o.local={list:t}:o.justSession=!0,createVuexAlong(o)(store)}function addPlugins(e){var r=e.getExtension("vue.plugins");null!==r&&r.forEach(function(e){return Vue.use(e)})}function addRoutes(e){var r=e.getExtension("vue.router.routes"),o=[],t={},n={};if(null!==r){r.forEach(function(e){if(e&&e.parent&&e.routes){var r,u=e.parent;"root"===u?r=o:void 0===(r=t[u])&&(n[u]=n[u]||[],r=n[u]),e.routes.forEach(function(e){r.push(e),function e(r){if(void 0!==r.children&&Array.isArray(r.children)){var o=r.name;if(void 0===o||""===o)return void console.log("Error: 路由名称未定义，"+JSON.stringify(r));var u=r.children;t[o]=u,n[o]&&(n[o].forEach(function(e){u.push(e)}),delete n[o]),r.children.forEach(function(r){e(r)})}}(e)})}});for(var u=0,a=Object.keys(n);u<a.length;u++){var i=a[u];console.log("Error: 父路由“"+i+"”不存在")}router.addRoutes(o),e.setAttribute("vue.routes",o)}}function addRouterHooks(e){var r=e.getExtension("vue.router.hooks");if(null!==r){var o=router;r.forEach(function(e){for(var r in e)void 0!==HOOK_KEYS[r]&&o[r](e[r])})}}function createVueInstance(e){var r=e.getExtension("vue.app"),o=r.component||{name:"app",render:function(e){return e("router-view")}},t={router:router,store:store,render:function(e){return e(o)}},n=e.getExtension("vue.options");null!==n&&(t.mixins=n);var u=new Vue(t),a=r.element||"#app";u.$mount(a),e.setAttribute("vue.instance",u)}var activator={start:function(e){addVuexModules(e),addPlugins(e),addRoutes(e),addRouterHooks(e),createVueInstance(e)}};export default activator;